unit HHelp;
(*
      EG. To open a CHM file
          HtmlHelp(GetDesktopWindow, "c:\Help.chm", HH_DISPLAY_TOPIC, 0);

      EG. To open a CHM file at a particular Topic
          HtmlHelp(GetDesktopWindow, "c:\Help.chm::/Intro.htm", HH_DISPLAY_TOPIC, 0);

      EG. To open a CHM file at a particular Topic and use a Window definition
          called "Mainwin".
          HtmlHelp(GetDesktopWindow, "c:\Help.chm::/Intro.htm>Mainwin", HH_DISPLAY_TOPIC, 0);

      EG. To open a CHM file using context help = 1001
          HtmlHelp(GetDesktopWindow, "c:\Help.chm", HH_HELP_CONTEXT, 1001);

      Note: Most people tend to use 0 instead of GetDesktopWindow.

      you MUST close any open help
      windows before shutting down the application or you will probably crash Windows.
      The call to close all windows is simply:

         HH.HtmlHelp(0, nil, HH_CLOSE_ALL, 0);

      Warning:
         Because of a bug in the HH API make sure you call this in your
         main form's OnCloseQuery event, not OnClose or OnDestroy. *)

interface

uses
  Windows;

var
  HtmlHelp: function(hwndCaller: HWND; pszFile: PChar;
    uCommand: UInt; dwData: DWORD): HWND; stdcall;
  ChmFile: String;

const
  HH_DISPLAY_TOPIC        = $0000;
  HH_HELP_CONTEXT         = $000F;  // display mapped numeric value in dwData
  HH_CLOSE_ALL            = $0012;  // close all windows opened directly or indirectly by the caller

implementation

var
  HHCtrlHandle: THandle = 0;

procedure LoadHtmlHelp;
begin
  if HHCtrlHandle = 0 then
  begin
    // v1.9 -- Normally 'hhctrl.ocx' is in the Windows search path
    HHCtrlHandle := LoadLibrary('hhctrl.ocx');
    if HHCtrlHandle <> 0 then
    begin
      @HtmlHelp := GetProcAddress(HHCtrlHandle, 'HtmlHelpA');
    end;
  end;
end;

procedure UnloadHtmlHelp;
begin
  if HHCtrlHandle <> 0 then
  begin
    FreeLibrary(HHCtrlHandle);
    @HtmlHelp := nil;
    HHCtrlHandle := 0;
  end;
end;

initialization
  LoadHtmlHelp;
finalization
  UnloadHtmlHelp;
end.
 